<?php

class actionContentCloneItem extends cmsAction {

    public function run($ctype, $id){
		
		$config = cmsConfig::getInstance();
		$model = cmsCore::getModel('content');
		$item = $model->getItemById('con_'.$ctype, $id);

		if($item){
			unset($item['id']);
			unset($item['slug']);
			unset($item['date_pub']);
			unset($item['date_approved']);
			unset($item['is_pub']);
			$item['is_approved'] = false;
			$ctype = $model->getContentTypeByName($ctype);
			$fields = $this->model->orderBy('ordering')->getContentFields($ctype['name']);
			$item = $model->addContentItem($ctype, $item, $fields);

			foreach($fields as $field){
				
				if($field['type'] == 'image'){
					$item[$field['name']] = $this->model->yamlToArray($item[$field['name']]);
					foreach($item[$field['name']] as $key=>$img){
						$item[$field['name']][$key] = str_replace('.', '-'.$item['id'].'.', $img);
						copy(PATH.$config->upload_root.$img, PATH.$config->upload_root.$item[$field['name']][$key]);
					}
				}
				
				if($field['type'] == 'images'){
					$item[$field['name']] = $this->model->yamlToArray($item[$field['name']]);
					foreach($item[$field['name']] as $num=>$image){
						foreach($image as $key=>$img){
							$item[$field['name']][$num][$key] = str_replace('.', '-'.$item['id'].'.', $img);
							copy(PATH.$config->upload_root.$img, PATH.$config->upload_root.$item[$field['name']][$num][$key]);
						}	
					}				
				}
			}
			
			$item = $model->updateContentItem($ctype, $item['id'], $item, $fields);
			echo '<div class="modalcloneitem">Копия успешно создана. ID записи - '.$item['id'].'<br><a href="/'.$ctype['name'].'/edit/'.$item['id'].'">Изменить</a></div>';
			
		} else {
			echo 'Не удалось создать копию записи!';
		}
		
		$this->halt();
   
	}
}
